--
-- Specialisation for JohnDeere7810
-- 
-- Author: CR

Vehicle.registerJointType("attachableFrontloader");

JohnDeere7810 = {};

function JohnDeere7810.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function JohnDeere7810:load(xmlFile)

    self.backHydraulic = {};
	self.backHydraulic.rootArm = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.backHydraulic#rootArm"));
	self.backHydraulic.bottomArm = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.backHydraulic#bottomArm"));
	self.frontAttacherJoint = {};
	self.frontAttacherJoint.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.trailerAttacherJoints#front"));
end;
	
function JohnDeere7810:delete()
end;

function JohnDeere7810:readStream(streamId, connection)
end;

function JohnDeere7810:writeStream(streamId, connection)
end;

function JohnDeere7810:mouseEvent(posX, posY, isDown, isUp, button)
end;

function JohnDeere7810:keyEvent(unicode, sym, modifier, isDown)
end;

function JohnDeere7810:update(dt)
    if self:getIsActive() then
		Cylindered.updateMovingPart(self, self.movingParts[1]);
        
        if self.backHydraulic ~= nil then
			local x, y, z = getRotation(self.backHydraulic.bottomArm);
			setRotation(self.backHydraulic.rootArm, x, y, z);
		end;
        
        for _, part in pairs(self.movingParts) do
			part.isDirty = true;
		end;
        
        local sx,sy,sz = getTranslation(self.sitz);
        local _,ry,_ = getTranslation(self.wheels[1].repr);
        setTranslation(self.sitz, sx, (ry+2.0895) /3, sz);   		
	end;
end;

function JohnDeere7810:draw()
end;